#pragma once

#include <string>
#include <vector>

class DictionaryTrie {
	
	private:
	enum {
		no_end = 0xffffffff,
	};
	
	private:
	struct EndNode {
		unsigned char type;
		unsigned int index;
	};
	struct TrieNode {
		unsigned char childtypes[26];
		unsigned int childs[26];
		std::vector<EndNode> endnodes;
		TrieNode();
	};
	
	std::vector<std::string> words;
	std::vector<TrieNode> trie;
	
	public:
	bool Load(const std::string& file);
	std::vector<std::string> Find(const std::string& filter);
	
	public:
	inline unsigned int GetWordCount() { return words.size(); }
	inline unsigned int GetTrieSize() { return trie.size(); }
	
};

